#line 1 "C:/Users/user/Desktop/3Phase PWM/3 Phase SPWM/3 Phase SPWM.c"
char i = 0;
#line 6 "C:/Users/user/Desktop/3Phase PWM/3 Phase SPWM/3 Phase SPWM.c"
unsigned char sin_table_0_180[33]={123,135,145,156,167,176,186,194,203,210,216,222,227,231,233,235,236,235,233,231,227,222,216,210,203,194,186,176,165,156,145,135,123};

unsigned char sin_table_120_300[33]= {222,227,231,233,235,236,235,233,231,227,222,216,210,203,194,186,176,165,156,145,135,123,123,135,145,156,167,176,186,194,203,210,216};

unsigned char sin_table_300_480[33]={216,210,203,194,186,176,165,156,145,135,123,123,135,145,156,167,176,186,194,203,210,216,222,227,231,233,235,236,235,233,231,227,222};
#line 17 "C:/Users/user/Desktop/3Phase PWM/3 Phase SPWM/3 Phase SPWM.c"
unsigned int frequency = 0;

unsigned int TBL_POINTER_NEW[3], TBL_POINTER_OLD[3], TBL_POINTER_SHIFT[3], SET_FREQ;
unsigned char DUTY_CYCLE[3];

void interrupt(){
 if (TMR2IF_bit == 1) {
 TBL_POINTER_NEW[0] = TBL_POINTER_OLD[0] + SET_FREQ ;
 if (TBL_POINTER_NEW[0] < TBL_POINTER_OLD[0]){
 CCP1CON.P1M1 = ~CCP1CON.P1M1;
 }

 TBL_POINTER_SHIFT[0] = TBL_POINTER_NEW[0] >> 11;
 DUTY_CYCLE[0] = TBL_POINTER_SHIFT[0];
 CCPR1L = sin_table_0_180[DUTY_CYCLE[0]];
 TBL_POINTER_OLD[0] = TBL_POINTER_NEW[0];

 TBL_POINTER_NEW[1] = TBL_POINTER_OLD[1] + SET_FREQ;
 if (TBL_POINTER_NEW[1] < TBL_POINTER_OLD[1]){
 CCP2CON.P2M1 = ~CCP2CON.P2M1;
 }


 TBL_POINTER_SHIFT[1] = TBL_POINTER_NEW[1] >> 11;
 DUTY_CYCLE[1] = TBL_POINTER_SHIFT[1];
 CCPR2L = sin_table_120_300[DUTY_CYCLE[1]];
 TBL_POINTER_OLD[1] = TBL_POINTER_NEW[1];

 TBL_POINTER_NEW[2] = TBL_POINTER_OLD[2] + SET_FREQ;
 if (TBL_POINTER_NEW[2] < TBL_POINTER_OLD[2]){
 CCP3CON.P1M1 = ~CCP3CON.P1M1;
 }
 TBL_POINTER_SHIFT[2] = TBL_POINTER_NEW[2] >> 11;
 DUTY_CYCLE[2] = TBL_POINTER_SHIFT[2];
 CCPR3L = sin_table_300_480[DUTY_CYCLE[2]];
 TBL_POINTER_OLD[2] = TBL_POINTER_NEW[2];

 TMR2IF_bit = 0;
 }
}

void main() {

 Delay_ms(10);


 APFCON = 0xFF;

 ADCON1 = 0b00100000;
 FVRCON = 0x00;

 ANSELA = 0x01;
 ANSELB = 0x00;

 CM1CON0 = 0x00;
 CM2CON0 = 0x00;

 TRISA = 0x00;

 PORTA = 0x00;
 PORTB = 0x00;
 PORTC = 0x00;

 LATA = 0x00;
 LATB = 0x00;
 LATC = 0x00;

 SET_FREQ = 287;

 for(i = 0; i < 3; i++) {
 TBL_POINTER_SHIFT[i] = 0;
 TBL_POINTER_NEW[i] = 0;
 TBL_POINTER_OLD[i] = 0;
 DUTY_CYCLE[i] = 0;
 }

 PR2 = 410;
 TRISB = 0xFF;
 TRISC = 0xFF;

 PWM1_Init(16000);
 PWM2_Init(16000);
 PWM3_Init(16000);

 PWM1_Set_Duty(0);
 PWM2_Set_Duty(0);
 PWM3_Set_Duty(0);

 PWM1_Start();
 PWM2_Start();
 PWM3_Start();

 TMR2IF_bit = 0;
 T2CON = 4;
 while(TMR2IF_bit == 0);
 TMR2IF_bit = 0;

 TRISB = 0x00;
 TRISC = 0x00;

 TMR2IE_bit = 1;
 PEIE_bit = 1;
 GIE_bit = 1;
 while(1) {

 }
}
