
_interrupt:

;3 Phase SPWM.c,22 :: 		void interrupt(){
;3 Phase SPWM.c,23 :: 		if (TMR2IF_bit == 1) {
	BTFSS      TMR2IF_bit+0, BitPos(TMR2IF_bit+0)
	GOTO       L_interrupt0
;3 Phase SPWM.c,24 :: 		TBL_POINTER_NEW[0] = TBL_POINTER_OLD[0] + SET_FREQ ;
	MOVF       _SET_FREQ+0, 0
	ADDWF      _TBL_POINTER_OLD+0, 0
	MOVWF      R1
	MOVF       _SET_FREQ+1, 0
	ADDWFC     _TBL_POINTER_OLD+1, 0
	MOVWF      R2
	MOVF       R1, 0
	MOVWF      _TBL_POINTER_NEW+0
	MOVF       R2, 0
	MOVWF      _TBL_POINTER_NEW+1
;3 Phase SPWM.c,25 :: 		if (TBL_POINTER_NEW[0] < TBL_POINTER_OLD[0]){
	MOVF       _TBL_POINTER_OLD+1, 0
	SUBWF      R2, 0
	BTFSS      STATUS+0, 2
	GOTO       L__interrupt14
	MOVF       _TBL_POINTER_OLD+0, 0
	SUBWF      R1, 0
L__interrupt14:
	BTFSC      STATUS+0, 0
	GOTO       L_interrupt1
;3 Phase SPWM.c,26 :: 		CCP1CON.P1M1 = ~CCP1CON.P1M1; //Reverse direction of full-bridge
	MOVLW      128
	XORWF      CCP1CON+0, 1
;3 Phase SPWM.c,27 :: 		}
L_interrupt1:
;3 Phase SPWM.c,29 :: 		TBL_POINTER_SHIFT[0] = TBL_POINTER_NEW[0] >> 11;
	MOVLW      11
	MOVWF      R2
	MOVF       _TBL_POINTER_NEW+0, 0
	MOVWF      R0
	MOVF       _TBL_POINTER_NEW+1, 0
	MOVWF      R1
	MOVF       R2, 0
L__interrupt15:
	BTFSC      STATUS+0, 2
	GOTO       L__interrupt16
	LSRF       R1, 1
	RRF        R0, 1
	ADDLW      255
	GOTO       L__interrupt15
L__interrupt16:
	MOVF       R0, 0
	MOVWF      _TBL_POINTER_SHIFT+0
	MOVF       R1, 0
	MOVWF      _TBL_POINTER_SHIFT+1
;3 Phase SPWM.c,30 :: 		DUTY_CYCLE[0] = TBL_POINTER_SHIFT[0];
	MOVF       R0, 0
	MOVWF      _DUTY_CYCLE+0
;3 Phase SPWM.c,31 :: 		CCPR1L = sin_table_0_180[DUTY_CYCLE[0]];
	MOVLW      _sin_table_0_180+0
	MOVWF      FSR0L
	MOVLW      hi_addr(_sin_table_0_180+0)
	MOVWF      FSR0H
	MOVF       R0, 0
	ADDWF      FSR0L, 1
	BTFSC      STATUS+0, 0
	INCF       FSR0H, 1
	MOVF       INDF0+0, 0
	MOVWF      CCPR1L+0
;3 Phase SPWM.c,32 :: 		TBL_POINTER_OLD[0] = TBL_POINTER_NEW[0];
	MOVF       _TBL_POINTER_NEW+0, 0
	MOVWF      _TBL_POINTER_OLD+0
	MOVF       _TBL_POINTER_NEW+1, 0
	MOVWF      _TBL_POINTER_OLD+1
;3 Phase SPWM.c,34 :: 		TBL_POINTER_NEW[1] = TBL_POINTER_OLD[1] + SET_FREQ;
	MOVF       _SET_FREQ+0, 0
	ADDWF      _TBL_POINTER_OLD+2, 0
	MOVWF      R1
	MOVF       _SET_FREQ+1, 0
	ADDWFC     _TBL_POINTER_OLD+3, 0
	MOVWF      R2
	MOVF       R1, 0
	MOVWF      _TBL_POINTER_NEW+2
	MOVF       R2, 0
	MOVWF      _TBL_POINTER_NEW+3
;3 Phase SPWM.c,35 :: 		if (TBL_POINTER_NEW[1] < TBL_POINTER_OLD[1]){
	MOVF       _TBL_POINTER_OLD+3, 0
	SUBWF      R2, 0
	BTFSS      STATUS+0, 2
	GOTO       L__interrupt17
	MOVF       _TBL_POINTER_OLD+2, 0
	SUBWF      R1, 0
L__interrupt17:
	BTFSC      STATUS+0, 0
	GOTO       L_interrupt2
;3 Phase SPWM.c,36 :: 		CCP2CON.P2M1 = ~CCP2CON.P2M1; //Reverse direction of full-bridge
	MOVLW      128
	XORWF      CCP2CON+0, 1
;3 Phase SPWM.c,37 :: 		}
L_interrupt2:
;3 Phase SPWM.c,40 :: 		TBL_POINTER_SHIFT[1] = TBL_POINTER_NEW[1] >> 11;
	MOVLW      11
	MOVWF      R2
	MOVF       _TBL_POINTER_NEW+2, 0
	MOVWF      R0
	MOVF       _TBL_POINTER_NEW+3, 0
	MOVWF      R1
	MOVF       R2, 0
L__interrupt18:
	BTFSC      STATUS+0, 2
	GOTO       L__interrupt19
	LSRF       R1, 1
	RRF        R0, 1
	ADDLW      255
	GOTO       L__interrupt18
L__interrupt19:
	MOVF       R0, 0
	MOVWF      _TBL_POINTER_SHIFT+2
	MOVF       R1, 0
	MOVWF      _TBL_POINTER_SHIFT+3
;3 Phase SPWM.c,41 :: 		DUTY_CYCLE[1] = TBL_POINTER_SHIFT[1];
	MOVF       R0, 0
	MOVWF      _DUTY_CYCLE+1
;3 Phase SPWM.c,42 :: 		CCPR2L = sin_table_120_300[DUTY_CYCLE[1]];
	MOVLW      _sin_table_120_300+0
	MOVWF      FSR0L
	MOVLW      hi_addr(_sin_table_120_300+0)
	MOVWF      FSR0H
	MOVF       R0, 0
	ADDWF      FSR0L, 1
	BTFSC      STATUS+0, 0
	INCF       FSR0H, 1
	MOVF       INDF0+0, 0
	MOVWF      CCPR2L+0
;3 Phase SPWM.c,43 :: 		TBL_POINTER_OLD[1] = TBL_POINTER_NEW[1];
	MOVF       _TBL_POINTER_NEW+2, 0
	MOVWF      _TBL_POINTER_OLD+2
	MOVF       _TBL_POINTER_NEW+3, 0
	MOVWF      _TBL_POINTER_OLD+3
;3 Phase SPWM.c,45 :: 		TBL_POINTER_NEW[2] = TBL_POINTER_OLD[2] + SET_FREQ;
	MOVF       _SET_FREQ+0, 0
	ADDWF      _TBL_POINTER_OLD+4, 0
	MOVWF      R1
	MOVF       _SET_FREQ+1, 0
	ADDWFC     _TBL_POINTER_OLD+5, 0
	MOVWF      R2
	MOVF       R1, 0
	MOVWF      _TBL_POINTER_NEW+4
	MOVF       R2, 0
	MOVWF      _TBL_POINTER_NEW+5
;3 Phase SPWM.c,46 :: 		if (TBL_POINTER_NEW[2] < TBL_POINTER_OLD[2]){
	MOVF       _TBL_POINTER_OLD+5, 0
	SUBWF      R2, 0
	BTFSS      STATUS+0, 2
	GOTO       L__interrupt20
	MOVF       _TBL_POINTER_OLD+4, 0
	SUBWF      R1, 0
L__interrupt20:
	BTFSC      STATUS+0, 0
	GOTO       L_interrupt3
;3 Phase SPWM.c,47 :: 		CCP3CON.P1M1 = ~CCP3CON.P1M1; //Reverse direction of full-bridge
	MOVLW      128
	XORWF      CCP3CON+0, 1
;3 Phase SPWM.c,48 :: 		}
L_interrupt3:
;3 Phase SPWM.c,49 :: 		TBL_POINTER_SHIFT[2] = TBL_POINTER_NEW[2] >> 11;
	MOVLW      11
	MOVWF      R2
	MOVF       _TBL_POINTER_NEW+4, 0
	MOVWF      R0
	MOVF       _TBL_POINTER_NEW+5, 0
	MOVWF      R1
	MOVF       R2, 0
L__interrupt21:
	BTFSC      STATUS+0, 2
	GOTO       L__interrupt22
	LSRF       R1, 1
	RRF        R0, 1
	ADDLW      255
	GOTO       L__interrupt21
L__interrupt22:
	MOVF       R0, 0
	MOVWF      _TBL_POINTER_SHIFT+4
	MOVF       R1, 0
	MOVWF      _TBL_POINTER_SHIFT+5
;3 Phase SPWM.c,50 :: 		DUTY_CYCLE[2] = TBL_POINTER_SHIFT[2];
	MOVF       R0, 0
	MOVWF      _DUTY_CYCLE+2
;3 Phase SPWM.c,51 :: 		CCPR3L = sin_table_300_480[DUTY_CYCLE[2]];
	MOVLW      _sin_table_300_480+0
	MOVWF      FSR0L
	MOVLW      hi_addr(_sin_table_300_480+0)
	MOVWF      FSR0H
	MOVF       R0, 0
	ADDWF      FSR0L, 1
	BTFSC      STATUS+0, 0
	INCF       FSR0H, 1
	MOVF       INDF0+0, 0
	MOVWF      CCPR3L+0
;3 Phase SPWM.c,52 :: 		TBL_POINTER_OLD[2] = TBL_POINTER_NEW[2];
	MOVF       _TBL_POINTER_NEW+4, 0
	MOVWF      _TBL_POINTER_OLD+4
	MOVF       _TBL_POINTER_NEW+5, 0
	MOVWF      _TBL_POINTER_OLD+5
;3 Phase SPWM.c,54 :: 		TMR2IF_bit = 0;
	BCF        TMR2IF_bit+0, BitPos(TMR2IF_bit+0)
;3 Phase SPWM.c,55 :: 		}
L_interrupt0:
;3 Phase SPWM.c,56 :: 		}
L_end_interrupt:
L__interrupt13:
	RETFIE     %s
; end of _interrupt

_main:

;3 Phase SPWM.c,58 :: 		void main() {
;3 Phase SPWM.c,60 :: 		Delay_ms(10);
	MOVLW      52
	MOVWF      R12
	MOVLW      241
	MOVWF      R13
L_main4:
	DECFSZ     R13, 1
	GOTO       L_main4
	DECFSZ     R12, 1
	GOTO       L_main4
	NOP
	NOP
;3 Phase SPWM.c,63 :: 		APFCON = 0xFF;
	MOVLW      255
	MOVWF      APFCON+0
;3 Phase SPWM.c,65 :: 		ADCON1 = 0b00100000;
	MOVLW      32
	MOVWF      ADCON1+0
;3 Phase SPWM.c,66 :: 		FVRCON = 0x00;
	CLRF       FVRCON+0
;3 Phase SPWM.c,68 :: 		ANSELA = 0x01;
	MOVLW      1
	MOVWF      ANSELA+0
;3 Phase SPWM.c,69 :: 		ANSELB = 0x00;
	CLRF       ANSELB+0
;3 Phase SPWM.c,71 :: 		CM1CON0 = 0x00;
	CLRF       CM1CON0+0
;3 Phase SPWM.c,72 :: 		CM2CON0 = 0x00;
	CLRF       CM2CON0+0
;3 Phase SPWM.c,74 :: 		TRISA = 0x00;
	CLRF       TRISA+0
;3 Phase SPWM.c,76 :: 		PORTA = 0x00;
	CLRF       PORTA+0
;3 Phase SPWM.c,77 :: 		PORTB = 0x00;
	CLRF       PORTB+0
;3 Phase SPWM.c,78 :: 		PORTC = 0x00;
	CLRF       PORTC+0
;3 Phase SPWM.c,80 :: 		LATA = 0x00;
	CLRF       LATA+0
;3 Phase SPWM.c,81 :: 		LATB = 0x00;
	CLRF       LATB+0
;3 Phase SPWM.c,82 :: 		LATC = 0x00;
	CLRF       LATC+0
;3 Phase SPWM.c,84 :: 		SET_FREQ = 287;
	MOVLW      31
	MOVWF      _SET_FREQ+0
	MOVLW      1
	MOVWF      _SET_FREQ+1
;3 Phase SPWM.c,86 :: 		for(i = 0; i < 3; i++) {
	CLRF       _i+0
L_main5:
	MOVLW      3
	SUBWF      _i+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L_main6
;3 Phase SPWM.c,87 :: 		TBL_POINTER_SHIFT[i] = 0;
	MOVF       _i+0, 0
	MOVWF      R0
	CLRF       R1
	LSLF       R0, 1
	RLF        R1, 1
	MOVLW      _TBL_POINTER_SHIFT+0
	ADDWF      R0, 0
	MOVWF      FSR1L
	MOVLW      hi_addr(_TBL_POINTER_SHIFT+0)
	ADDWFC     R1, 0
	MOVWF      FSR1H
	CLRF       INDF1+0
	ADDFSR     1, 1
	CLRF       INDF1+0
;3 Phase SPWM.c,88 :: 		TBL_POINTER_NEW[i] = 0;
	MOVF       _i+0, 0
	MOVWF      R0
	CLRF       R1
	LSLF       R0, 1
	RLF        R1, 1
	MOVLW      _TBL_POINTER_NEW+0
	ADDWF      R0, 0
	MOVWF      FSR1L
	MOVLW      hi_addr(_TBL_POINTER_NEW+0)
	ADDWFC     R1, 0
	MOVWF      FSR1H
	CLRF       INDF1+0
	ADDFSR     1, 1
	CLRF       INDF1+0
;3 Phase SPWM.c,89 :: 		TBL_POINTER_OLD[i] = 0;
	MOVF       _i+0, 0
	MOVWF      R0
	CLRF       R1
	LSLF       R0, 1
	RLF        R1, 1
	MOVLW      _TBL_POINTER_OLD+0
	ADDWF      R0, 0
	MOVWF      FSR1L
	MOVLW      hi_addr(_TBL_POINTER_OLD+0)
	ADDWFC     R1, 0
	MOVWF      FSR1H
	CLRF       INDF1+0
	ADDFSR     1, 1
	CLRF       INDF1+0
;3 Phase SPWM.c,90 :: 		DUTY_CYCLE[i] = 0;
	MOVLW      _DUTY_CYCLE+0
	MOVWF      FSR1L
	MOVLW      hi_addr(_DUTY_CYCLE+0)
	MOVWF      FSR1H
	MOVF       _i+0, 0
	ADDWF      FSR1L, 1
	BTFSC      STATUS+0, 0
	INCF       FSR1H, 1
	CLRF       INDF1+0
;3 Phase SPWM.c,86 :: 		for(i = 0; i < 3; i++) {
	INCF       _i+0, 1
;3 Phase SPWM.c,91 :: 		}
	GOTO       L_main5
L_main6:
;3 Phase SPWM.c,93 :: 		PR2 = 410;
	MOVLW      154
	MOVWF      PR2+0
;3 Phase SPWM.c,94 :: 		TRISB = 0xFF;
	MOVLW      255
	MOVWF      TRISB+0
;3 Phase SPWM.c,95 :: 		TRISC = 0xFF;
	MOVLW      255
	MOVWF      TRISC+0
;3 Phase SPWM.c,97 :: 		PWM1_Init(16000);
	BCF        T2CON+0, 0
	BCF        T2CON+0, 1
	MOVLW      249
	MOVWF      PR2+0
	CALL       _PWM1_Init+0
;3 Phase SPWM.c,98 :: 		PWM2_Init(16000);
	BCF        T2CON+0, 0
	BCF        T2CON+0, 1
	MOVLW      249
	MOVWF      PR2+0
	CALL       _PWM2_Init+0
;3 Phase SPWM.c,99 :: 		PWM3_Init(16000);
	BCF        T2CON+0, 0
	BCF        T2CON+0, 1
	MOVLW      249
	MOVWF      PR2+0
	CALL       _PWM3_Init+0
;3 Phase SPWM.c,101 :: 		PWM1_Set_Duty(0);
	CLRF       FARG_PWM1_Set_Duty_new_duty+0
	CALL       _PWM1_Set_Duty+0
;3 Phase SPWM.c,102 :: 		PWM2_Set_Duty(0);
	CLRF       FARG_PWM2_Set_Duty_new_duty+0
	CALL       _PWM2_Set_Duty+0
;3 Phase SPWM.c,103 :: 		PWM3_Set_Duty(0);
	CLRF       FARG_PWM3_Set_Duty_new_duty+0
	CALL       _PWM3_Set_Duty+0
;3 Phase SPWM.c,105 :: 		PWM1_Start();
	CALL       _PWM1_Start+0
;3 Phase SPWM.c,106 :: 		PWM2_Start();
	CALL       _PWM2_Start+0
;3 Phase SPWM.c,107 :: 		PWM3_Start();
	CALL       _PWM3_Start+0
;3 Phase SPWM.c,109 :: 		TMR2IF_bit = 0;
	BCF        TMR2IF_bit+0, BitPos(TMR2IF_bit+0)
;3 Phase SPWM.c,110 :: 		T2CON = 4;
	MOVLW      4
	MOVWF      T2CON+0
;3 Phase SPWM.c,111 :: 		while(TMR2IF_bit == 0);
L_main8:
	BTFSC      TMR2IF_bit+0, BitPos(TMR2IF_bit+0)
	GOTO       L_main9
	GOTO       L_main8
L_main9:
;3 Phase SPWM.c,112 :: 		TMR2IF_bit = 0;
	BCF        TMR2IF_bit+0, BitPos(TMR2IF_bit+0)
;3 Phase SPWM.c,114 :: 		TRISB = 0x00;
	CLRF       TRISB+0
;3 Phase SPWM.c,115 :: 		TRISC = 0x00;
	CLRF       TRISC+0
;3 Phase SPWM.c,117 :: 		TMR2IE_bit = 1;
	BSF        TMR2IE_bit+0, BitPos(TMR2IE_bit+0)
;3 Phase SPWM.c,118 :: 		PEIE_bit = 1;
	BSF        PEIE_bit+0, BitPos(PEIE_bit+0)
;3 Phase SPWM.c,119 :: 		GIE_bit = 1;
	BSF        GIE_bit+0, BitPos(GIE_bit+0)
;3 Phase SPWM.c,120 :: 		while(1) {
L_main10:
;3 Phase SPWM.c,122 :: 		}
	GOTO       L_main10
;3 Phase SPWM.c,123 :: 		}
L_end_main:
	GOTO       $+0
; end of _main
